#ifndef AUDIOSYS_H__
#define AUDIOSYS_H__

#include "nestypes.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef Int32 (__fastcall *AUDIOHANDLER)(void);
typedef struct NES_AUDIO_HANDLER_TAG {
	Uint fSkip;
	AUDIOHANDLER Proc;
	struct NES_AUDIO_HANDLER_TAG *next;
} NES_AUDIO_HANDLER;

typedef void (__fastcall *VOLUMEHANDLER)(Uint volume);
typedef struct NES_VOLUME_HANDLER_TAG {
	VOLUMEHANDLER Proc;
	struct NES_VOLUME_HANDLER_TAG *next;
} NES_VOLUME_HANDLER;


void NESAudioRender(Int16 *bufp, Uint buflen);
void NESAudioHandlerInstall(NES_AUDIO_HANDLER *ph);
void NESAudioFrequencySet(Uint freq);
Uint NESAudioFrequencyGet(void);
void NESAudioHandlerInitialize(void);
void NESVolumeHandlerInstall(NES_VOLUME_HANDLER *ph);
void NESVolume(Uint volume);

#ifdef __cplusplus
}
#endif

#endif /* AUDIOSYS_H__ */
