#ifndef HANDLER_H__
#define HANDLER_H__

#include "nestypes.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef Uint (__fastcall *READHANDLER)(Uint a);
typedef void (__fastcall *WRITEHANDLER)(Uint a, Uint v);
typedef void (__fastcall *RESETHANDLER)(void);
typedef void (__fastcall *TERMINATEHANDLER)(void);

typedef struct NES_READ_HANDLER_TAG {
	Uint min;
	Uint max;
	READHANDLER Proc;
	struct NES_READ_HANDLER_TAG *next;
} NES_READ_HANDLER;

typedef struct NES_WRITE_HANDLER_TAG {
	Uint min;
	Uint max;
	WRITEHANDLER Proc;
	struct NES_WRITE_HANDLER_TAG *next;
} NES_WRITE_HANDLER;

typedef struct NES_RESET_HANDLER_TAG {
	Uint priority;	/* 0(first) - 15(last) */
	RESETHANDLER Proc;
	struct NES_RESET_HANDLER_TAG *next;
} NES_RESET_HANDLER;
#define NES_RESET_SYS_FIRST 4
#define NES_RESET_SYS_NOMAL 8
#define NES_RESET_SYS_LAST 12

typedef struct NES_TERMINATE_HANDLER_TAG {
	TERMINATEHANDLER Proc;
	struct NES_TERMINATE_HANDLER_TAG *next;
} NES_TERMINATE_HANDLER;

void NESReadHandlerInstall(NES_READ_HANDLER *ph);
void NESWriteHandlerInstall(NES_WRITE_HANDLER *ph);
void NESReset(void);
void NESResetHandlerInstall(NES_RESET_HANDLER *ph);
void NESTerminate(void);
void NESTerminateHandlerInstall(NES_TERMINATE_HANDLER *ph);
void NESHandlerInitialize(void);

#ifdef __cplusplus
}
#endif

#endif /* HANDLER_H__ */
