#ifndef NES6502_H__
#define NES6502_H__

#include "handler.h"

#ifdef __cplusplus
extern "C" {
#endif

#define USE_CALLBACK	1
#define USE_INLINEMMC	12
#define USE_USERPOINTER	0

void NES6502ReadHandlerSet(Uint bank, READHANDLER rh);
void NES6502WriteHandlerSet(Uint bank, WRITEHANDLER wh);
void NES6502SetZeropage(void *p);
Uint NES6502Execute(Uint total_cycles);
void NES6502BreakPoint(Uint A);
void NES6502Irq(void);
void NES6502Nmi(void);
Uint NES6502Read(Uint A);

typedef struct {
	Uint PC;
	Uint8 A;
	Uint8 X;
	Uint8 Y;
	Uint8 P;
	Uint8 S;
} NES6502_CONTEXT;
void NES6502ContextGet(NES6502_CONTEXT *p);
void NES6502ContextSet(const NES6502_CONTEXT *p);


void NES6502Initialize(void);
void NES6502Reset(void);

#ifdef __cplusplus
}
#endif

#endif /* NES6502_H__ */
