/*  XMMS - Cross-platform multimedia player
 *  Copyright (C) 1998-2000  Peter Alm, Mikael Alm, Olle Hallnas, Thomas Nilsson and 4Front Technologies
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
#ifndef NSF_H
#define NSF_H

#include <pthread.h>

#include <stdlib.h>
#include <string.h>
#include <stdio.h>

#include <glib.h>
#include <gtk/gtk.h>

#include <xmms/plugin.h>
#include <xmms/xmmsctrl.h>
#include <xmms/configfile.h>
#include <xmms/util.h>

#include "widget.h"
#include "skin.h"
#include "pbutton.h"
#include "dock.h"

#include "nsflib.h"

typedef struct
{
	FILE *file;
	short channels, bits_per_sample, eof, going, eos, eok;
	long samples_per_sec;
	int position, length;
	int seek_to, data_offset;	
	guchar total_songs;
	guchar start_song;
	guchar current_song;
	guchar name[32];
	guchar artist[32];
	guchar copyright[32];
}
NsfFile;

typedef struct
{
	gint play_time;
	gint fadeout_time;
	// reserve
	gint resolution;
	gint channels;
	gint downsample;
	gint downsample_custom;
	gboolean player_shaded;
	gboolean easy_move;
}
NsfConfig;

typedef struct
{
	GtkWidget *window;
	GtkWidget *main;
	GdkGC *gc;
	gboolean focus;
	GdkPixmap *bg;
	GList *wlist;
	PButton *menubtn;
	PButton *minimize;
	PButton	*shade;
	PButton *close;
	PButton *rew;
	PButton *play;
	PButton *pause;
	PButton	*stop;
	PButton *fwd;
	PButton *eject;
	GList *dock_window_list;
}
NsfWin;

extern NsfConfig nsf_cfg;
extern NsfFile *nsf_file;
extern NsfWin nsfwin,*nsf_win;
extern InputPlugin nsf_ip;

/* from xmms main.c */
extern GtkWidget *mainwin;
extern GList *dock_window_list;

extern void nsf_configure(void);
extern void draw_nsf_window(gboolean force);
#endif
