/*  XMMS - Cross-platform multimedia player
 *  Copyright (C) 1998-2000  Peter Alm, Mikael Alm, Olle Hallnas, Thomas Nilsson and 4Front Technologies
 *  Copyright (C) 1999,2000  Hvard Kvlen
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

/*	
 *	customize for xmms nsf 
 */

#include "skin.h"

GdkPixmap *get_skin_pixmap(SkinIndex si)
{
	SkinPixmap *skin_pixmap = NULL;
	switch (si)
	{
		case SKIN_MAIN:
			skin_pixmap = &skin->main;
			break;
		case SKIN_CBUTTONS:
			skin_pixmap = &skin->cbuttons;
			break;
		case SKIN_TITLEBAR:
			skin_pixmap = &skin->titlebar;
			break;
		case SKIN_SHUFREP:
			skin_pixmap = &skin->shufrep;
			break;
		case SKIN_TEXT:
			skin_pixmap = &skin->text;
			break;
		case SKIN_VOLUME:
			skin_pixmap = &skin->volume;
			break;
		case SKIN_BALANCE:
			skin_pixmap = &skin->balance;
			break;
		case SKIN_MONOSTEREO:
			skin_pixmap = &skin->monostereo;
			break;
		case SKIN_PLAYPAUSE:
			skin_pixmap = &skin->playpause;
			break;
		case SKIN_NUMBERS:
			skin_pixmap = &skin->numbers;
			break;
		case SKIN_POSBAR:
			skin_pixmap = &skin->posbar;
			break;
		case SKIN_PLEDIT:
			skin_pixmap = &skin->pledit;
			break;
		case SKIN_EQMAIN:
			skin_pixmap = &skin->eqmain;
			break;
		case SKIN_EQ_EX:
			skin_pixmap = &skin->eq_ex;
			break;
		default:
			g_error("Unable to find skin pixmap");
			return NULL;
			break;
	}
	if ( skin_pixmap != NULL ) {
		if ( skin_pixmap->pixmap == NULL ) {
			return skin_pixmap->def_pixmap; 
		} else {
			return skin_pixmap->pixmap;
		}
	}
	return NULL;
}
